use 5.006;
use strict;
use warnings;

# this test was generated with Dist::Zilla::Plugin::Test::Compile 2.058

use Test::More;

plan tests => 41 + ($ENV{AUTHOR_TESTING} ? 1 : 0);

my @module_files = (
    'Data/Sah/Coerce.pm',
    'Data/Sah/Coerce/js/bool/float.pm',
    'Data/Sah/Coerce/js/bool/str.pm',
    'Data/Sah/Coerce/js/date/float_epoch.pm',
    'Data/Sah/Coerce/js/date/obj_Date.pm',
    'Data/Sah/Coerce/js/date/str.pm',
    'Data/Sah/Coerce/js/datenotime/float_epoch.pm',
    'Data/Sah/Coerce/js/datenotime/obj_Date.pm',
    'Data/Sah/Coerce/js/datenotime/str.pm',
    'Data/Sah/Coerce/js/datetime/float_epoch.pm',
    'Data/Sah/Coerce/js/datetime/obj_Date.pm',
    'Data/Sah/Coerce/js/datetime/str.pm',
    'Data/Sah/Coerce/js/duration/float_secs.pm',
    'Data/Sah/Coerce/js/duration/str_iso8601.pm',
    'Data/Sah/Coerce/js/timeofday/str_hms.pm',
    'Data/Sah/Coerce/perl/bool/str.pm',
    'Data/Sah/Coerce/perl/date/float_epoch.pm',
    'Data/Sah/Coerce/perl/date/float_epoch_always.pm',
    'Data/Sah/Coerce/perl/date/obj_DateTime.pm',
    'Data/Sah/Coerce/perl/date/obj_TimeMoment.pm',
    'Data/Sah/Coerce/perl/date/str_iso8601.pm',
    'Data/Sah/Coerce/perl/datenotime/float_epoch.pm',
    'Data/Sah/Coerce/perl/datenotime/float_epoch_always.pm',
    'Data/Sah/Coerce/perl/datenotime/obj_DateTime.pm',
    'Data/Sah/Coerce/perl/datenotime/obj_TimeMoment.pm',
    'Data/Sah/Coerce/perl/datenotime/str_iso8601.pm',
    'Data/Sah/Coerce/perl/datetime/float_epoch.pm',
    'Data/Sah/Coerce/perl/datetime/float_epoch_always.pm',
    'Data/Sah/Coerce/perl/datetime/obj_DateTime.pm',
    'Data/Sah/Coerce/perl/datetime/obj_TimeMoment.pm',
    'Data/Sah/Coerce/perl/datetime/str_iso8601.pm',
    'Data/Sah/Coerce/perl/duration/float_secs.pm',
    'Data/Sah/Coerce/perl/duration/obj_DateTimeDuration.pm',
    'Data/Sah/Coerce/perl/duration/str_human.pm',
    'Data/Sah/Coerce/perl/duration/str_iso8601.pm',
    'Data/Sah/Coerce/perl/float/str_percent.pm',
    'Data/Sah/Coerce/perl/int/str_percent.pm',
    'Data/Sah/Coerce/perl/timeofday/obj_DateTimeOfDay.pm',
    'Data/Sah/Coerce/perl/timeofday/str_hms.pm',
    'Data/Sah/CoerceCommon.pm',
    'Data/Sah/CoerceJS.pm'
);



# no fake home requested

my @switches = (
    -d 'blib' ? '-Mblib' : '-Ilib',
);

use File::Spec;
use IPC::Open3;
use IO::Handle;

open my $stdin, '<', File::Spec->devnull or die "can't open devnull: $!";

my @warnings;
for my $lib (@module_files)
{
    # see L<perlfaq8/How can I capture STDERR from an external command?>
    my $stderr = IO::Handle->new;

    diag('Running: ', join(', ', map { my $str = $_; $str =~ s/'/\\'/g; q{'} . $str . q{'} }
            $^X, @switches, '-e', "require q[$lib]"))
        if $ENV{PERL_COMPILE_TEST_DEBUG};

    my $pid = open3($stdin, '>&STDERR', $stderr, $^X, @switches, '-e', "require q[$lib]");
    binmode $stderr, ':crlf' if $^O eq 'MSWin32';
    my @_warnings = <$stderr>;
    waitpid($pid, 0);
    is($?, 0, "$lib loaded ok");

    shift @_warnings if @_warnings and $_warnings[0] =~ /^Using .*\bblib/
        and not eval { +require blib; blib->VERSION('1.01') };

    if (@_warnings)
    {
        warn @_warnings;
        push @warnings, @_warnings;
    }
}



is(scalar(@warnings), 0, 'no warnings found')
    or diag 'got warnings: ', ( Test::More->can('explain') ? Test::More::explain(\@warnings) : join("\n", '', @warnings) ) if $ENV{AUTHOR_TESTING};


